diff -Nurp '--exclude=.bzr*' tin-2.6.4/src/attrib.c tin-2.6.5/src/attrib.c
--- tin-2.6.4/src/attrib.c	2024-12-01 15:06:21.000000000 +0100
+++ tin-2.6.5/src/attrib.c	2025-12-08 20:26:41.003314892 +0100
@@ -3,10 +3,10 @@
  *  Module    : attrib.c
  *  Author    : I. Lea
  *  Created   : 1993-12-01
- *  Updated   : 2024-12-01
+ *  Updated   : 2025-12-08
  *  Notes     : Group attribute routines
  *
- * Copyright (c) 1993-2025 Iain Lea <iain@bricbrac.de>
+ * Copyright (c) 1993-2026 Iain Lea <iain@bricbrac.de>
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -58,7 +58,8 @@ int attrib_file_offset;
 /*
  * Local prototypes
  */
-static t_bool skip_scope(struct t_scope *scope);
+static t_bool skip_scope(const struct t_scope *scope);
+static void add_scope_to_list(struct t_group *group, struct t_scope *scope);
 static void set_attrib(int type, const char *scope, const char *line, void *data);
 static void set_default_attributes(struct t_attribute *attributes, struct t_attribute *scope, t_bool global);
 static void set_default_state(struct t_attribute_state *state);
@@ -125,7 +126,7 @@ set_default_attributes(
 	CopyBool(suppress_soft_hyphens, tinrc.suppress_soft_hyphens);
 #endif /* MULTIBYTE_ABLE && !NO_LOCALE */
 	CopyBits(trim_article_body, tinrc.trim_article_body);
-	CopyBool(verbatim_handling, tinrc.verbatim_handling);
+	CopyBits(verbatim_handling, tinrc.verbatim_handling);
 #ifdef HAVE_COLOR
 	CopyBool(extquote_handling, tinrc.extquote_handling);
 #endif /* HAVE_COLOR */
@@ -139,7 +140,9 @@ set_default_attributes(
 	attributes->auto_select = FALSE;
 	CopyBool(batch_save, tinrc.batch_save);
 	attributes->delete_tmp_files = FALSE;
+	attributes->getart_limit = tinrc.getart_limit;
 	CopyBool(group_catchup_on_exit, tinrc.group_catchup_on_exit);
+	CopyBits(hide_inline_data, tinrc.hide_inline_data);
 	CopyBool(mail_8bit_header, tinrc.mail_8bit_header);
 	CopyBits(mail_mime_encoding, tinrc.mail_mime_encoding);
 	CopyBool(mark_ignore_tags, tinrc.mark_ignore_tags);
@@ -192,8 +195,10 @@ set_default_state(
 	state->fcc = FALSE;
 	state->followup_to = FALSE;
 	state->from = FALSE;
+	state->getart_limit = FALSE;
 	state->group_catchup_on_exit = FALSE;
 	state->group_format = FALSE;
+	state->hide_inline_data = FALSE;
 #ifdef HAVE_ISPELL
 	state->ispell = FALSE;
 #endif /* HAVE_ISPELL */
@@ -334,19 +339,20 @@ read_attributes_file(
 	}
 
 	if (!batch_mode || verbose)
-		wait_message(0, _(txt_reading_attributes_file), global_file ? _(txt_global) : "", file);
+		wait_message(0, global_file ? _(txt_reading_global_attributes_file) : _(txt_reading_attributes_file), file);
 
 	tmp = my_malloc(sizeof(char *));
 	*tmp = NULL;
 
 	if ((fp = tin_fopen(file, "r")) != NULL) {
-		unsigned int errors = 0, ln = 0;
+		unsigned int hide_global_errors = 0, errors = 0, ln = 0;
 
 		*scope = '\0';
 		while ((line = tin_fgets(fp, FALSE)) != NULL) {
 			++ln;
 			if (!*line)
 				continue;
+
 			if (line[0] == '#') {
 				if (!global_file) {
 					if (!*scope)
@@ -395,10 +401,15 @@ read_attributes_file(
 					break;
 
 				case 'g':
+					MATCH_INTEGER("getart_limit=", OPT_ATTRIB_GETART_LIMIT, 0);
 					MATCH_BOOLEAN("group_catchup_on_exit=", OPT_ATTRIB_GROUP_CATCHUP_ON_EXIT);
 					MATCH_STRING("group_format=", OPT_ATTRIB_GROUP_FORMAT);
 					break;
 
+				case 'h':
+					MATCH_INTEGER("hide_inline_data=", OPT_ATTRIB_HIDE_INLINE_DATA, HIDE_ALL);
+					break;
+
 				case 'i':
 #ifdef HAVE_ISPELL
 					MATCH_STRING("ispell=", OPT_ATTRIB_ISPELL);
@@ -511,7 +522,22 @@ read_attributes_file(
 
 				case 'u':
 #ifdef CHARSET_CONVERSION
-					MATCH_STRING("undeclared_charset=", OPT_ATTRIB_UNDECLARED_CHARSET);
+					if (strlen(line) - strlen("undeclared_charset=") < BUF_SIZE - 1 &&
+						match_string(line, "undeclared_charset=", buf, sizeof(buf))) {
+						if (validate_charset(buf) != NULL) {
+							*tmp = my_strdup(buf);
+							set_attrib(OPT_ATTRIB_UNDECLARED_CHARSET, scope, line, *tmp);
+							*tmp = NULL;
+						}
+#	ifdef DEBUG
+						else {
+							if (debug & DEBUG_ATTRIB)
+								debug_print_file("ATTRIBUTES", "# Line %d, %s: %s\n", ln, txt_invalid_char_in_charset, line); /* TODO -> lang.c? */
+						}
+#	endif /* DEBUG */
+						found = TRUE;
+						break;
+					}
 #	ifdef USE_ICU_UCSDET
 					MATCH_BOOLEAN("undeclared_cs_guess=", OPT_ATTRIB_UNDECLARED_CS_GUESS);
 #	else
@@ -523,7 +549,10 @@ read_attributes_file(
 					break;
 
 				case 'v':
-					MATCH_BOOLEAN("verbatim_handling=", OPT_ATTRIB_VERBATIM_HANDLING);
+					/* verbatim_handling has changed from bool to int in ATTRIBUTES_VERSION == 1.0.12 */
+					if (upgrade && upgrade->file_version >= 10012) {
+						MATCH_INTEGER("verbatim_handling=", OPT_ATTRIB_VERBATIM_HANDLING, 3);
+					}
 					break;
 
 				case 'w':
@@ -545,6 +574,7 @@ read_attributes_file(
 				int show_info;
 				t_bool auto_bcc;
 				t_bool auto_cc;
+				t_bool verbatim_handling;
 
 				switch (my_tolower((unsigned char) line[0])) {
 					case 'a':
@@ -620,7 +650,7 @@ read_attributes_file(
 							if (upgrade && upgrade->file_version < 10009) {
 								char *newbuf = my_malloc(sizeof(buf) + 3); /* " %G" */
 
-								sprintf(newbuf, "%s %s", buf, "%G");
+								sprintf(newbuf, "%s %%G", buf);
 								set_attrib(OPT_ATTRIB_SIGFILE, scope, line, newbuf);
 							}
 							break;
@@ -633,6 +663,15 @@ read_attributes_file(
 						MATCH_INTEGER("thread_arts=", OPT_ATTRIB_THREAD_ARTICLES, THREAD_MAX);
 						break;
 
+					case 'v':
+						/* verbatim_handling has changed from bool to int in ATTRIBUTES_VERSION == 1.0.12 */
+						if (upgrade && upgrade->file_version < 10012 && match_boolean(line, "verbatim_handling=", &verbatim_handling)) {
+							num = verbatim_handling ? VERBATIM_SHOW_ALL : VERBATIM_NONE;
+							set_attrib(OPT_ATTRIB_VERBATIM_HANDLING, scope, line, &num);
+							found = TRUE;
+						}
+						break;
+
 					default:
 						break;
 				}
@@ -642,29 +681,40 @@ read_attributes_file(
 				found = FALSE;
 			else { /* TODO: even without DEBUG? */
 				char *p;
-				const char *msg;
+				const char *msg = NULL;
 
 				++errors;
 				if ((p = strchr(line, '='))) {
-					*p = '\0';
-					if (strlen(p + 1) >= BUF_SIZE - 1)
+					if (strlen(p + 1) >= BUF_SIZE - 1) {
 						msg = _(txt_error_attrib_too_long);
-					else
-						msg = _(txt_error_attrib_unknown);
+						*p = '\0';
+					} else {
+						/*
+						 * on option upgrades like bool -> int hide
+						 * error message in the glocal-file from user
+						 * as they usually do not have the permissions
+						 * to fix it
+						 */
+						if (global_file)
+							++hide_global_errors;
+						else
+							msg = _(txt_error_attrib_unknown);
+					}
 				} else
 					msg = _(txt_error_attrib_malformed);
 
-				my_fprintf(stderr, msg, ln, line); /* TODO: add log_formatted_msg("ERR", ...)? */
+				if (msg)
+					my_fprintf(stderr, msg, ln, line); /* TODO: add log_formatted_msg("ERR", ...)? */
 #ifdef DEBUG
 				if (debug & (DEBUG_ATTRIB))
-					debug_print_file("ATTRIBUTES", txt_bad_attrib, line);
+					debug_print_file("ATTRIBUTES", global_file ? _(txt_bad_global_attrib) : _(txt_bad_attrib), line);
 #endif /* DEBUG */
 			}
 		}
-		if (errors) {
+		if (errors != hide_global_errors) {
 			my_fflush(stderr);
 			if (!batch_mode)
-				sleep(errors > 15 ? 7 : (errors >> 1) | 0x01);
+				sleep((errors - hide_global_errors) > 15 ? 7 : ((errors - hide_global_errors) >> 1) | 0x01);
 		}
 		fclose(fp);
 
@@ -732,6 +782,11 @@ read_attributes_file(
 	break
 
 #define SET_INTEGER(value) \
+	curr_scope->attribute->value = *((int *) data); \
+	curr_scope->state->value = TRUE; \
+	break
+
+#define SET_NUMBER(value) \
 	curr_scope->attribute->value = CAST_BITS(*((int *) data), value); \
 	curr_scope->state->value = TRUE; \
 	break
@@ -799,7 +854,7 @@ set_attrib(
 				SET_BOOLEAN(ask_for_metamail);
 
 			case OPT_ATTRIB_AUTO_CC_BCC:
-				SET_INTEGER(auto_cc_bcc);
+				SET_NUMBER(auto_cc_bcc);
 
 			case OPT_ATTRIB_AUTO_LIST_THREAD:
 				SET_BOOLEAN(auto_list_thread);
@@ -819,17 +874,23 @@ set_attrib(
 			case OPT_ATTRIB_EDITOR_FORMAT:
 				SET_STRING(editor_format);
 
+			case OPT_ATTRIB_GETART_LIMIT:
+				SET_INTEGER(getart_limit);
+
 			case OPT_ATTRIB_GROUP_CATCHUP_ON_EXIT:
 				SET_BOOLEAN(group_catchup_on_exit);
 
 			case OPT_ATTRIB_GROUP_FORMAT:
 				SET_STRING(group_format);
 
+			case OPT_ATTRIB_HIDE_INLINE_DATA:
+				SET_NUMBER(hide_inline_data);
+
 			case OPT_ATTRIB_MAIL_8BIT_HEADER:
 				SET_BOOLEAN(mail_8bit_header);
 
 			case OPT_ATTRIB_MAIL_MIME_ENCODING:
-				SET_INTEGER(mail_mime_encoding);
+				SET_NUMBER(mail_mime_encoding);
 
 			case OPT_ATTRIB_MARK_IGNORE_TAGS:
 				SET_BOOLEAN(mark_ignore_tags);
@@ -874,7 +935,7 @@ set_attrib(
 				SET_BOOLEAN(post_8bit_header);
 
 			case OPT_ATTRIB_POST_MIME_ENCODING:
-				SET_INTEGER(post_mime_encoding);
+				SET_NUMBER(post_mime_encoding);
 
 			case OPT_ATTRIB_POST_PROCESS_VIEW:
 				SET_BOOLEAN(post_process_view);
@@ -905,7 +966,7 @@ set_attrib(
 				SET_BOOLEAN(signature_repost);
 
 			case OPT_ATTRIB_THREAD_ARTICLES:
-				SET_INTEGER(thread_articles);
+				SET_NUMBER(thread_articles);
 
 			case OPT_ATTRIB_THREAD_CATCHUP_ON_EXIT:
 				SET_BOOLEAN(thread_catchup_on_exit);
@@ -914,10 +975,10 @@ set_attrib(
 				SET_STRING(thread_format);
 
 			case OPT_ATTRIB_THREAD_PERC:
-				SET_INTEGER(thread_perc);
+				SET_NUMBER(thread_perc);
 
 			case OPT_ATTRIB_SHOW_AUTHOR:
-				SET_INTEGER(show_author);
+				SET_NUMBER(show_author);
 
 			case OPT_ATTRIB_SHOW_SIGNATURES:
 				SET_BOOLEAN(show_signatures);
@@ -931,25 +992,25 @@ set_attrib(
 #endif /* MULTIBYTE_ABLE && !NO_LOCALE */
 
 			case OPT_ATTRIB_TRIM_ARTICLE_BODY:
-				SET_INTEGER(trim_article_body);
+				SET_NUMBER(trim_article_body);
 
 			case OPT_ATTRIB_VERBATIM_HANDLING:
-				SET_BOOLEAN(verbatim_handling);
+				SET_NUMBER(verbatim_handling);
 
 			case OPT_ATTRIB_WRAP_ON_NEXT_UNREAD:
 				SET_BOOLEAN(wrap_on_next_unread);
 
 			case OPT_ATTRIB_SORT_ARTICLE_TYPE:
-				SET_INTEGER(sort_article_type);
+				SET_NUMBER(sort_article_type);
 
 			case OPT_ATTRIB_SORT_THREADS_TYPE:
-				SET_INTEGER(sort_threads_type);
+				SET_NUMBER(sort_threads_type);
 
 			case OPT_ATTRIB_POST_PROCESS_TYPE:
-				SET_INTEGER(post_process_type);
+				SET_NUMBER(post_process_type);
 
 			case OPT_ATTRIB_QUICK_KILL_HEADER:
-				SET_INTEGER(quick_kill_header);
+				SET_NUMBER(quick_kill_header);
 
 			case OPT_ATTRIB_QUICK_KILL_SCOPE:
 				SET_STRING(quick_kill_scope);
@@ -961,7 +1022,7 @@ set_attrib(
 				SET_BOOLEAN(quick_kill_case);
 
 			case OPT_ATTRIB_QUICK_SELECT_HEADER:
-				SET_INTEGER(quick_select_header);
+				SET_NUMBER(quick_select_header);
 
 			case OPT_ATTRIB_QUICK_SELECT_SCOPE:
 				SET_STRING(quick_select_scope);
@@ -977,7 +1038,7 @@ set_attrib(
 
 #ifdef CHARSET_CONVERSION
 			case OPT_ATTRIB_MM_NETWORK_CHARSET:
-				SET_INTEGER(mm_network_charset);
+				SET_NUMBER(mm_network_charset);
 
 			case OPT_ATTRIB_UNDECLARED_CHARSET:
 				SET_STRING(undeclared_charset);
@@ -1049,6 +1110,32 @@ add_scope(
 }
 
 
+static void
+add_scope_to_list(
+	struct t_group *group,
+	struct t_scope *scope)
+{
+	struct t_scope_list *curr;
+
+	if (!group || !scope)
+		return;
+
+	curr = group->scopes_list;
+
+	if (!curr)
+		curr = group->scopes_list = my_malloc(sizeof(struct t_scope_list));
+	else {
+		while (curr->next)
+			curr = curr->next;
+
+		curr = curr->next = my_malloc(sizeof(struct t_scope_list));
+	}
+
+	curr->scope = scope;
+	curr->next = NULL;
+}
+
+
 #define SET_ATTRIB(attr) do { \
 		if (curr_scope->state->attr) \
 			group->attribute->attr = curr_scope->attribute->attr; \
@@ -1080,6 +1167,7 @@ assign_attributes_to_groups(
 			spin_cursor();
 		group = &active[i];
 		found = FALSE;
+		free_scopes_list(group);
 		for (j = 1; j < num_scope; j++) {
 			curr_scope = &scopes[j];
 			if (match_group_list(group->name, curr_scope->scope)) {
@@ -1092,6 +1180,7 @@ assign_attributes_to_groups(
 					set_default_attributes(group->attribute, default_scope->attribute, FALSE);
 					found = TRUE;
 				}
+				add_scope_to_list(group, curr_scope);
 				SET_ATTRIB(maildir);
 				SET_ATTRIB(savedir);
 				SET_ATTRIB(savefile);
@@ -1155,7 +1244,9 @@ assign_attributes_to_groups(
 				SET_ATTRIB(auto_select);
 				SET_ATTRIB(batch_save);
 				SET_ATTRIB(delete_tmp_files);
+				SET_ATTRIB(getart_limit);
 				SET_ATTRIB(group_catchup_on_exit);
+				SET_ATTRIB(hide_inline_data);
 				SET_ATTRIB(mail_8bit_header);
 				SET_ATTRIB(mail_mime_encoding);
 				SET_ATTRIB(mark_ignore_tags);
@@ -1237,6 +1328,30 @@ assign_attributes_to_groups(
 
 
 /*
+ * check if getart_limit is set via attributes for the given group
+ */
+t_bool
+getart_limit_set_from_scope(
+	struct t_group *group)
+{
+	struct t_scope_list *curr;
+
+	if (group && group->scopes_list) {
+		curr = group->scopes_list;
+
+		while (curr) {
+			if (curr->scope->state->getart_limit)
+				return TRUE;
+
+			curr = curr->next;
+		}
+	}
+
+	return FALSE;
+}
+
+
+/*
  * (re)build scope->headers_to_[not_]display array
  */
 void
@@ -1319,8 +1434,15 @@ write_attributes_file(
 	fprintf(fp, "%s", _(txt_attrib_file_fcc));
 	fprintf(fp, "%s", _(txt_attrib_file_followup_to));
 	fprintf(fp, "%s", _(txt_attrib_file_from));
+	fprintf(fp, "%s", _(txt_attrib_file_getart_limit));
 	fprintf(fp, "%s", _(txt_attrib_file_grp_catchup));
 	fprintf(fp, "%s", _(txt_attrib_file_grp_fmt));
+	fprintf(fp, "%s", _(txt_attrib_file_hide_inline_data));
+	fprintf(fp, "%s", _(txt_attrib_file_hide_inline_data_0));
+	fprintf(fp, "%s", _(txt_attrib_file_hide_inline_data_1));
+	fprintf(fp, "%s", _(txt_attrib_file_hide_inline_data_2));
+	fprintf(fp, "%s", _(txt_attrib_file_hide_inline_data_4));
+	fprintf(fp, "%s", _(txt_attrib_file_hide_inline_data_8));
 	fprintf(fp, "%s", _(txt_attrib_file_mail_8bit_hdr));
 	fprintf(fp, "%s", _(txt_attrib_file_mail_mime_enc));
 	for (i = 0; txt_mime_encodings[i] != NULL; i++) {
@@ -1374,20 +1496,20 @@ write_attributes_file(
 	fprintf(fp, "%s", _(txt_attrib_file_quick_kill_expire));
 	fprintf(fp, "%s", _(txt_attrib_file_quick_kill_case));
 	fprintf(fp, "%s", _(txt_attrib_file_quick_kill_hdr));
-	fprintf(fp, "%s", _(txt_attrib_file_quick_kill_hdr_0_1));
-	fprintf(fp, "%s", _(txt_attrib_file_quick_kill_hdr_2_3));
-	fprintf(fp, "%s", _(txt_attrib_file_quick_kill_hdr_4));
-	fprintf(fp, "%s", _(txt_attrib_file_quick_kill_hdr_5));
-	fprintf(fp, "%s", _(txt_attrib_file_quick_kill_hdr_6));
+	fprintf(fp, "%s", _(txt_attrib_file_quick_ks_hdr_0_1));
+	fprintf(fp, "%s", _(txt_attrib_file_quick_ks_hdr_2_3));
+	fprintf(fp, "%s", _(txt_attrib_file_quick_ks_hdr_4));
+	fprintf(fp, "%s", _(txt_attrib_file_quick_ks_hdr_5));
+	fprintf(fp, "%s", _(txt_attrib_file_quick_ks_hdr_6));
 	fprintf(fp, "%s", _(txt_attrib_file_quick_select_scope));
 	fprintf(fp, "%s", _(txt_attrib_file_quick_select_expire));
 	fprintf(fp, "%s", _(txt_attrib_file_quick_select_case));
 	fprintf(fp, "%s", _(txt_attrib_file_quick_select_hdr));
-	fprintf(fp, "%s", _(txt_attrib_file_quick_select_hdr_0_1));
-	fprintf(fp, "%s", _(txt_attrib_file_quick_select_hdr_2_3));
-	fprintf(fp, "%s", _(txt_attrib_file_quick_select_hdr_4));
-	fprintf(fp, "%s", _(txt_attrib_file_quick_select_hdr_5));
-	fprintf(fp, "%s", _(txt_attrib_file_quick_select_hdr_6));
+	fprintf(fp, "%s", _(txt_attrib_file_quick_ks_hdr_0_1));
+	fprintf(fp, "%s", _(txt_attrib_file_quick_ks_hdr_2_3));
+	fprintf(fp, "%s", _(txt_attrib_file_quick_ks_hdr_4));
+	fprintf(fp, "%s", _(txt_attrib_file_quick_ks_hdr_5));
+	fprintf(fp, "%s", _(txt_attrib_file_quick_ks_hdr_6));
 	fprintf(fp, "%s", _(txt_attrib_file_quote_chars));
 #ifndef DISABLE_PRINTING
 	fprintf(fp, "%s", _(txt_attrib_file_print_hdr));
@@ -1459,6 +1581,10 @@ write_attributes_file(
 	fprintf(fp, "%s", _(txt_attrib_file_trim_art_body_6));
 	fprintf(fp, "%s", _(txt_attrib_file_trim_art_body_7));
 	fprintf(fp, "%s", _(txt_attrib_file_verbatim_handling));
+	fprintf(fp, "%s", _(txt_attrib_file_verbatim_handling_0));
+	fprintf(fp, "%s", _(txt_attrib_file_verbatim_handling_1));
+	fprintf(fp, "%s", _(txt_attrib_file_verbatim_handling_2));
+	fprintf(fp, "%s", _(txt_attrib_file_verbatim_handling_3));
 #ifdef HAVE_COLOR
 	fprintf(fp, "%s", _(txt_attrib_file_extquote_handling));
 #endif /* HAVE_COLOR */
@@ -1506,6 +1632,7 @@ write_attributes_file(
 			if (!scope->global) {
 				if (skip_scope(scope))
 					continue;
+
 				fprintf(fp, "\nscope=%s\n", scope->scope);
 				if (scope->state->add_posted_to_filter)
 					fprintf(fp, "add_posted_to_filter=%s\n", print_boolean(scope->attribute->add_posted_to_filter));
@@ -1539,10 +1666,14 @@ write_attributes_file(
 					fprintf(fp, "followup_to=%s\n", *scope->attribute->followup_to);
 				if (ATTRIB_IS_SET(from))
 					fprintf(fp, "from=%s\n", *scope->attribute->from);
+				if (scope->state->getart_limit)
+					fprintf(fp, "getart_limit=%d\n", scope->attribute->getart_limit);
 				if (scope->state->group_catchup_on_exit)
 					fprintf(fp, "group_catchup_on_exit=%s\n", print_boolean(scope->attribute->group_catchup_on_exit));
 				if (ATTRIB_IS_SET(group_format))
 					fprintf(fp, "group_format=%s\n", *scope->attribute->group_format);
+				if (scope->state->hide_inline_data)
+					fprintf(fp, "hide_inline_data=%u\n", (unsigned) scope->attribute->hide_inline_data);
 				if (scope->state->mail_8bit_header)
 					fprintf(fp, "mail_8bit_header=%s\n", print_boolean(scope->attribute->mail_8bit_header));
 				if (scope->state->mail_mime_encoding)
@@ -1656,7 +1787,7 @@ write_attributes_file(
 				if (scope->state->trim_article_body)
 					fprintf(fp, "trim_article_body=%u\n", (unsigned) scope->attribute->trim_article_body);
 				if (scope->state->verbatim_handling)
-					fprintf(fp, "verbatim_handling=%s\n", print_boolean(scope->attribute->verbatim_handling));
+					fprintf(fp, "verbatim_handling=%u\n", (unsigned) scope->attribute->verbatim_handling);
 				if (scope->state->wrap_on_next_unread)
 					fprintf(fp, "wrap_on_next_unread=%s\n", print_boolean(scope->attribute->wrap_on_next_unread));
 				if (ATTRIB_IS_SET(x_headers))
@@ -1697,7 +1828,7 @@ write_attributes_file(
  */
 static t_bool
 skip_scope(
-	struct t_scope *scope)
+	const struct t_scope *scope)
 {
 	return !(scope->state->add_posted_to_filter
 		|| scope->state->advertising
@@ -1716,8 +1847,10 @@ skip_scope(
 		|| ATTRIB_IS_SET(fcc)
 		|| ATTRIB_IS_SET(followup_to)
 		|| ATTRIB_IS_SET(from)
+		|| scope->state->getart_limit
 		|| scope->state->group_catchup_on_exit
 		|| ATTRIB_IS_SET(group_format)
+		|| scope->state->hide_inline_data
 		|| scope->state->mail_8bit_header
 		|| scope->state->mail_mime_encoding
 #ifdef HAVE_ISPELL
@@ -1827,13 +1960,21 @@ dump_attributes(
 	if (debug & DEBUG_ATTRIB) {
 		int i, j;
 		struct t_group *group;
+		struct t_scope_list *sl;
 
 		for_each_group(i) {
 			group = &active[i];
 			if (!group->attribute)
 				continue;
+
 			debug_print_file("ATTRIBUTES", "group=%s", BlankIfNull(group->name));
 			debug_print_file("ATTRIBUTES", "\tGlobal=%d", group->attribute->global);
+			debug_print_file("ATTRIBUTES", "\tMatching scopes:");
+			if ((sl = group->scopes_list)) {
+				for (; sl != NULL; sl = sl->next)
+					debug_print_file("ATTRIBUTES", "\t\t%s", BlankIfNull(sl->scope->scope));
+			} else
+				debug_print_file("ATTRIBUTES", "\t\tNo matching scopes");
 			debug_print_file("ATTRIBUTES", "\tmaildir=%s", DEBUG_PRINT_BLANK_IF_NULL(maildir));
 			debug_print_file("ATTRIBUTES", "\tsavedir=%s", DEBUG_PRINT_BLANK_IF_NULL(savedir));
 			debug_print_file("ATTRIBUTES", "\tsavefile=%s", DEBUG_PRINT_BLANK_IF_NULL(savefile));
@@ -1867,8 +2008,10 @@ dump_attributes(
 #	ifdef HAVE_COLOR
 			debug_print_file("ATTRIBUTES", "\textquote_handling=%s", print_boolean(group->attribute->extquote_handling));
 #	endif /* HAVE_COLOR */
+			debug_print_file("ATTRIBUTES", "\tgetart_limit=%d", group->attribute->getart_limit);
 			debug_print_file("ATTRIBUTES", "\tgroup_catchup_on_exit=%s", print_boolean(group->attribute->group_catchup_on_exit));
 			debug_print_file("ATTRIBUTES", "\tgroup_format=%s", DEBUG_PRINT_BLANK_IF_NULL(group_format));
+			debug_print_file("ATTRIBUTES", "\thide_inline_data=%d", group->attribute->hide_inline_data);
 			debug_print_file("ATTRIBUTES", "\tmail_8bit_header=%s", print_boolean(group->attribute->mail_8bit_header));
 			debug_print_file("ATTRIBUTES", "\tmail_mime_encoding=%s", txt_mime_encodings[group->attribute->mail_mime_encoding]);
 			debug_print_file("ATTRIBUTES", "\tmark_ignore_tags=%s", print_boolean(group->attribute->mark_ignore_tags));
@@ -1907,7 +2050,7 @@ dump_attributes(
 			debug_print_file("ATTRIBUTES", "\tthread_catchup_on_exit=%s", print_boolean(group->attribute->thread_catchup_on_exit));
 			debug_print_file("ATTRIBUTES", "\tthread_format=%s", DEBUG_PRINT_BLANK_IF_NULL(thread_format));
 			debug_print_file("ATTRIBUTES", "\ttrim_article_body=%d", group->attribute->trim_article_body);
-			debug_print_file("ATTRIBUTES", "\tverbatim_handling=%s", print_boolean(group->attribute->verbatim_handling));
+			debug_print_file("ATTRIBUTES", "\tverbatim_handling=%d", group->attribute->verbatim_handling);
 			debug_print_file("ATTRIBUTES", "\twrap_on_next_unread=%s", print_boolean(group->attribute->wrap_on_next_unread));
 			debug_print_file("ATTRIBUTES", "\tpost_process_type=%d", group->attribute->post_process_type);
 			debug_print_file("ATTRIBUTES", "\tquick_kill_scope=%s", DEBUG_PRINT_BLANK_IF_NULL(quick_kill_scope));
@@ -1988,8 +2131,10 @@ dump_scopes(
 #	ifdef HAVE_COLOR
 			debug_print_file(fname, "\t%sextquote_handling=%s", DEBUG_PRINT_STATE(extquote_handling), print_boolean(scope->attribute->extquote_handling));
 #	endif /* HAVE_COLOR */
+			debug_print_file(fname, "\t%sgetart_limit=%d", DEBUG_PRINT_STATE(getart_limit), scope->attribute->getart_limit);
 			debug_print_file(fname, "\t%sgroup_catchup_on_exit=%s", DEBUG_PRINT_STATE(group_catchup_on_exit), print_boolean(scope->attribute->group_catchup_on_exit));
 			debug_print_file(fname, "\t%sgroup_format=%s", DEBUG_PRINT_STATE(group_format), DEBUG_PRINT_STRING(group_format));
+			debug_print_file(fname, "\t%shide_inline_data=%d", DEBUG_PRINT_STATE(hide_inline_data), scope->attribute->hide_inline_data);
 			debug_print_file(fname, "\t%smail_8bit_header=%s", DEBUG_PRINT_STATE(mail_8bit_header), print_boolean(scope->attribute->mail_8bit_header));
 			debug_print_file(fname, "\t%smail_mime_encoding=%s", DEBUG_PRINT_STATE(mail_mime_encoding), txt_mime_encodings[scope->attribute->mail_mime_encoding]);
 			debug_print_file(fname, "\t%smark_ignore_tags=%s", DEBUG_PRINT_STATE(mark_ignore_tags), print_boolean(scope->attribute->mark_ignore_tags));
@@ -2028,7 +2173,7 @@ dump_scopes(
 			debug_print_file(fname, "\t%sthread_catchup_on_exit=%s", DEBUG_PRINT_STATE(thread_catchup_on_exit), print_boolean(scope->attribute->thread_catchup_on_exit));
 			debug_print_file(fname, "\t%sthread_format=%s", DEBUG_PRINT_STATE(thread_format), DEBUG_PRINT_STRING(thread_format));
 			debug_print_file(fname, "\t%strim_article_body=%d", DEBUG_PRINT_STATE(trim_article_body), scope->attribute->trim_article_body);
-			debug_print_file(fname, "\t%sverbatim_handling=%s", DEBUG_PRINT_STATE(verbatim_handling), print_boolean(scope->attribute->verbatim_handling));
+			debug_print_file(fname, "\t%sverbatim_handling=%d", DEBUG_PRINT_STATE(verbatim_handling), scope->attribute->verbatim_handling);
 			debug_print_file(fname, "\t%swrap_on_next_unread=%s", DEBUG_PRINT_STATE(wrap_on_next_unread), print_boolean(scope->attribute->wrap_on_next_unread));
 			debug_print_file(fname, "\t%spost_process_type=%d", DEBUG_PRINT_STATE(post_process_type), scope->attribute->post_process_type);
 			debug_print_file(fname, "\t%squick_kill_scope=%s", DEBUG_PRINT_STATE(quick_kill_scope), DEBUG_PRINT_STRING(quick_kill_scope));
